
from flask import Flask, request
from flask_restful import Resource, Api
from flask_cors import CORS

import trendnet_api.suggestion as suggestion
# from threading import Thread

class Get_Suggestions(Resource):
  def get(self):
    args = request.args
    term = args['term']
    return suggestion.get_suggestions(term)

class Get_Concept_Name(Resource):
  def get(self):
    args = request.args
    cui = args['cui']
    return suggestion.get_concept_name(cui)

def start_api():
  app = Flask(__name__)
  CORS(app)
  api = Api(app)
  api.add_resource(Get_Suggestions, '/get_new_concepts')
  api.add_resource(Get_Concept_Name,'/get_concept_name')
  app.run(host='0.0.0.0', debug=False, use_reloader=False)
  print("App is running.")
  