import argparse
from typing import NamedTuple,List
from trendnet_api.suggestion_utils import CandidateGenerator

candidate_generator = CandidateGenerator()
trendnet = candidate_generator.lkb

def get_suggestions(term,k=30,filter_for_definitions=False,no_definition_threshold=.95,threshold = 0.7):
  candidates = candidate_generator([term],k)[0]
  predicted = []
  for cand in candidates:
    concept = trendnet.get_concept(cand.concept_id)
    score = max(cand.similarities)
    if (
        (not (filter_for_definitions
              and concept.definition == "MISSING"
              and score < no_definition_threshold)
        )
        or score > threshold
    ):
      predicted.append((concept, score))
  sorted_predicted = sorted(predicted, reverse=True, key=lambda x: x[1])
  suggested_concepts = [concept for concept,_ in sorted_predicted]
  results = []
  for concept in suggested_concepts:
    terms = [term.string for term in trendnet.get_terms_from_concept_id(concept.id)]
    results.append({"cui":concept.id,"concept_name":concept.concept_name,"semantic_type":concept.semantic_type,"definition":concept.definition,"terms":terms})
  return results

def get_concept_info(cui):
    concept = trendnet.get_concept(cui)
    terms = [term.string for term in trendnet.get_terms_from_concept_id(cui)]
    related_concepts = 
    return cui,concept.concept_name,concept.semantic_type,concept.definition,terms,related_concepts

if __name__ == '__main__':
  parser = argparse.ArgumentParser()

  parser.add_argument(
    '--term',
    help="Term to be searched"
  )

  parser.add_argument(
    '--k',
    help="Number of aliases to look at during KNN."
  )
  args = parser.parse_args()
  suggestions = get_suggestions(args.term,3)
  print(suggestions)